# DO NOT EDIT! This file is automatically generated

import marshmallow

from commercetools import helpers, types
from commercetools.schemas._base import (
    PagedQueryResponseSchema,
    UpdateActionSchema,
    UpdateSchema,
)
from commercetools.schemas._common import (
    LocalizedStringField,
    ReferenceSchema,
    ResourceSchema,
)

__all__ = [
    "ProductDiscountChangeIsActiveActionSchema",
    "ProductDiscountChangeNameActionSchema",
    "ProductDiscountChangePredicateActionSchema",
    "ProductDiscountChangeSortOrderActionSchema",
    "ProductDiscountChangeValueActionSchema",
    "ProductDiscountDraftSchema",
    "ProductDiscountMatchQuerySchema",
    "ProductDiscountPagedQueryResponseSchema",
    "ProductDiscountReferenceSchema",
    "ProductDiscountSchema",
    "ProductDiscountSetDescriptionActionSchema",
    "ProductDiscountSetValidFromActionSchema",
    "ProductDiscountSetValidFromAndUntilActionSchema",
    "ProductDiscountSetValidUntilActionSchema",
    "ProductDiscountUpdateActionSchema",
    "ProductDiscountUpdateSchema",
    "ProductDiscountValueAbsoluteSchema",
    "ProductDiscountValueExternalSchema",
    "ProductDiscountValueRelativeSchema",
    "ProductDiscountValueSchema",
]


class ProductDiscountDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountDraft`."
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas._product_discount.ProductDiscountValueAbsoluteSchema",
            "external": "commercetools.schemas._product_discount.ProductDiscountValueExternalSchema",
            "relative": "commercetools.schemas._product_discount.ProductDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    predicate = marshmallow.fields.String(allow_none=True)
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountDraft(**data)


class ProductDiscountMatchQuerySchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountMatchQuery`."
    product_id = marshmallow.fields.String(allow_none=True, data_key="productId")
    variant_id = marshmallow.fields.Integer(allow_none=True, data_key="variantId")
    staged = marshmallow.fields.Bool(allow_none=True)
    price = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.PriceSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountMatchQuery(**data)


class ProductDiscountPagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountPagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas._product_discount.ProductDiscountSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountPagedQueryResponse(**data)


class ProductDiscountReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas._product_discount.ProductDiscountSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ProductDiscountReference(**data)


class ProductDiscountSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscount`."
    name = LocalizedStringField(allow_none=True)
    description = LocalizedStringField(allow_none=True, missing=None)
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas._product_discount.ProductDiscountValueAbsoluteSchema",
            "external": "commercetools.schemas._product_discount.ProductDiscountValueExternalSchema",
            "relative": "commercetools.schemas._product_discount.ProductDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )
    predicate = marshmallow.fields.String(allow_none=True)
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")
    references = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("typeId", "type_id"),
            discriminator_schemas={
                "cart-discount": "commercetools.schemas._cart_discount.CartDiscountReferenceSchema",
                "cart": "commercetools.schemas._cart.CartReferenceSchema",
                "category": "commercetools.schemas._category.CategoryReferenceSchema",
                "channel": "commercetools.schemas._channel.ChannelReferenceSchema",
                "key-value-document": "commercetools.schemas._custom_object.CustomObjectReferenceSchema",
                "customer-group": "commercetools.schemas._customer_group.CustomerGroupReferenceSchema",
                "customer": "commercetools.schemas._customer.CustomerReferenceSchema",
                "discount-code": "commercetools.schemas._discount_code.DiscountCodeReferenceSchema",
                "inventory-entry": "commercetools.schemas._inventory.InventoryEntryReferenceSchema",
                "order-edit": "commercetools.schemas._order_edit.OrderEditReferenceSchema",
                "order": "commercetools.schemas._order.OrderReferenceSchema",
                "payment": "commercetools.schemas._payment.PaymentReferenceSchema",
                "product-discount": "commercetools.schemas._product_discount.ProductDiscountReferenceSchema",
                "product-type": "commercetools.schemas._product_type.ProductTypeReferenceSchema",
                "product": "commercetools.schemas._product.ProductReferenceSchema",
                "review": "commercetools.schemas._review.ReviewReferenceSchema",
                "shipping-method": "commercetools.schemas._shipping_method.ShippingMethodReferenceSchema",
                "shopping-list": "commercetools.schemas._shopping_list.ShoppingListReferenceSchema",
                "state": "commercetools.schemas._state.StateReferenceSchema",
                "tax-category": "commercetools.schemas._tax_category.TaxCategoryReferenceSchema",
                "type": "commercetools.schemas._type.TypeReferenceSchema",
                "zone": "commercetools.schemas._zone.ZoneReferenceSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        )
    )
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscount(**data)


class ProductDiscountUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountUpdateAction(**data)


class ProductDiscountUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "changeIsActive": "commercetools.schemas._product_discount.ProductDiscountChangeIsActiveActionSchema",
                "changeName": "commercetools.schemas._product_discount.ProductDiscountChangeNameActionSchema",
                "changePredicate": "commercetools.schemas._product_discount.ProductDiscountChangePredicateActionSchema",
                "changeSortOrder": "commercetools.schemas._product_discount.ProductDiscountChangeSortOrderActionSchema",
                "changeValue": "commercetools.schemas._product_discount.ProductDiscountChangeValueActionSchema",
                "setDescription": "commercetools.schemas._product_discount.ProductDiscountSetDescriptionActionSchema",
                "setValidFrom": "commercetools.schemas._product_discount.ProductDiscountSetValidFromActionSchema",
                "setValidFromAndUntil": "commercetools.schemas._product_discount.ProductDiscountSetValidFromAndUntilActionSchema",
                "setValidUntil": "commercetools.schemas._product_discount.ProductDiscountSetValidUntilActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ProductDiscountUpdate(**data)


class ProductDiscountValueSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValue`."
    type = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValue(**data)


class ProductDiscountChangeIsActiveActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeIsActiveAction`."
    is_active = marshmallow.fields.Bool(allow_none=True, data_key="isActive")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeIsActiveAction(**data)


class ProductDiscountChangeNameActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeNameAction`."
    name = LocalizedStringField(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeNameAction(**data)


class ProductDiscountChangePredicateActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangePredicateAction`."
    predicate = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangePredicateAction(**data)


class ProductDiscountChangeSortOrderActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeSortOrderAction`."
    sort_order = marshmallow.fields.String(allow_none=True, data_key="sortOrder")

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeSortOrderAction(**data)


class ProductDiscountChangeValueActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountChangeValueAction`."
    value = helpers.Discriminator(
        discriminator_field=("type", "type"),
        discriminator_schemas={
            "absolute": "commercetools.schemas._product_discount.ProductDiscountValueAbsoluteSchema",
            "external": "commercetools.schemas._product_discount.ProductDiscountValueExternalSchema",
            "relative": "commercetools.schemas._product_discount.ProductDiscountValueRelativeSchema",
        },
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountChangeValueAction(**data)


class ProductDiscountSetDescriptionActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetDescriptionAction`."
    description = LocalizedStringField(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetDescriptionAction(**data)


class ProductDiscountSetValidFromActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetValidFromAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetValidFromAction(**data)


class ProductDiscountSetValidFromAndUntilActionSchema(
    ProductDiscountUpdateActionSchema
):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetValidFromAndUntilAction`."
    valid_from = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validFrom"
    )
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetValidFromAndUntilAction(**data)


class ProductDiscountSetValidUntilActionSchema(ProductDiscountUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountSetValidUntilAction`."
    valid_until = marshmallow.fields.DateTime(
        allow_none=True, missing=None, data_key="validUntil"
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ProductDiscountSetValidUntilAction(**data)


class ProductDiscountValueAbsoluteSchema(ProductDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValueAbsolute`."
    money = marshmallow.fields.Nested(
        nested="commercetools.schemas._common.MoneySchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValueAbsolute(**data)


class ProductDiscountValueExternalSchema(ProductDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValueExternal`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValueExternal(**data)


class ProductDiscountValueRelativeSchema(ProductDiscountValueSchema):
    "Marshmallow schema for :class:`commercetools.types.ProductDiscountValueRelative`."
    permyriad = marshmallow.fields.Integer(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type"]
        return types.ProductDiscountValueRelative(**data)
