# DO NOT EDIT! This file is automatically generated

import marshmallow

from commercetools import helpers, types
from commercetools.schemas._base import (
    PagedQueryResponseSchema,
    UpdateActionSchema,
    UpdateSchema,
)
from commercetools.schemas._common import ReferenceSchema, ResourceSchema

__all__ = [
    "LocationSchema",
    "ZoneAddLocationActionSchema",
    "ZoneChangeNameActionSchema",
    "ZoneDraftSchema",
    "ZonePagedQueryResponseSchema",
    "ZoneReferenceSchema",
    "ZoneRemoveLocationActionSchema",
    "ZoneSchema",
    "ZoneSetDescriptionActionSchema",
    "ZoneSetKeyActionSchema",
    "ZoneUpdateActionSchema",
    "ZoneUpdateSchema",
]


class LocationSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.Location`."
    country = marshmallow.fields.String()
    state = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Location(**data)


class ZoneDraftSchema(marshmallow.Schema):
    "Marshmallow schema for :class:`commercetools.types.ZoneDraft`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    locations = marshmallow.fields.Nested(
        nested="commercetools.schemas._zone.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZoneDraft(**data)


class ZonePagedQueryResponseSchema(PagedQueryResponseSchema):
    "Marshmallow schema for :class:`commercetools.types.ZonePagedQueryResponse`."
    results = marshmallow.fields.Nested(
        nested="commercetools.schemas._zone.ZoneSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZonePagedQueryResponse(**data)


class ZoneReferenceSchema(ReferenceSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneReference`."
    obj = marshmallow.fields.Nested(
        nested="commercetools.schemas._zone.ZoneSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        missing=None,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["type_id"]
        return types.ZoneReference(**data)


class ZoneSchema(ResourceSchema):
    "Marshmallow schema for :class:`commercetools.types.Zone`."
    key = marshmallow.fields.String(allow_none=True, missing=None)
    name = marshmallow.fields.String(allow_none=True)
    description = marshmallow.fields.String(allow_none=True, missing=None)
    locations = marshmallow.fields.Nested(
        nested="commercetools.schemas._zone.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
        many=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.Zone(**data)


class ZoneUpdateActionSchema(UpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneUpdateAction`."

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneUpdateAction(**data)


class ZoneUpdateSchema(UpdateSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneUpdate`."
    actions = marshmallow.fields.List(
        helpers.Discriminator(
            discriminator_field=("action", "action"),
            discriminator_schemas={
                "addLocation": "commercetools.schemas._zone.ZoneAddLocationActionSchema",
                "changeName": "commercetools.schemas._zone.ZoneChangeNameActionSchema",
                "removeLocation": "commercetools.schemas._zone.ZoneRemoveLocationActionSchema",
                "setDescription": "commercetools.schemas._zone.ZoneSetDescriptionActionSchema",
                "setKey": "commercetools.schemas._zone.ZoneSetKeyActionSchema",
            },
            unknown=marshmallow.EXCLUDE,
            allow_none=True,
        ),
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        return types.ZoneUpdate(**data)


class ZoneAddLocationActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneAddLocationAction`."
    location = marshmallow.fields.Nested(
        nested="commercetools.schemas._zone.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneAddLocationAction(**data)


class ZoneChangeNameActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneChangeNameAction`."
    name = marshmallow.fields.String(allow_none=True)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneChangeNameAction(**data)


class ZoneRemoveLocationActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneRemoveLocationAction`."
    location = marshmallow.fields.Nested(
        nested="commercetools.schemas._zone.LocationSchema",
        unknown=marshmallow.EXCLUDE,
        allow_none=True,
    )

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneRemoveLocationAction(**data)


class ZoneSetDescriptionActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneSetDescriptionAction`."
    description = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneSetDescriptionAction(**data)


class ZoneSetKeyActionSchema(ZoneUpdateActionSchema):
    "Marshmallow schema for :class:`commercetools.types.ZoneSetKeyAction`."
    key = marshmallow.fields.String(allow_none=True, missing=None)

    class Meta:
        unknown = marshmallow.EXCLUDE

    @marshmallow.post_load
    def post_load(self, data):
        del data["action"]
        return types.ZoneSetKeyAction(**data)
